com.holonplatform.vaadin.flow.components

## Interface Components.view

- Enclosing interface:
    Components

      public static interface Components.view

  `ViewComponent` and `PropertyViewGroup` builders provider.

- - ### Method Summary

    All Methods Static Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <T> ViewComponentBuilder<T>` | `component(Class<? extends T> valueType)` Get a `ViewComponentBuilder` to create a `ViewComponent` using given value type.
    `static <T> ViewComponentBuilder<T>` | `component(Function<T,String> stringValueConverter)` Get a `ViewComponentBuilder` to create a `ViewComponent` using given function to convert the value to a `String` type representation.
    `static <T> ViewComponentBuilder<T>` | `component(com.holonplatform.core.property.Property<T> property)` Get a `ViewComponentBuilder` to create a `ViewComponent` using given `Property` for label and value presentation through the `Property.present(Object)` method.
    `static <C extends com.vaadin.flow.component.Component,P extends com.holonplatform.core.property.Property> PropertyViewFormBuilder<C>` | `form(C content, Iterable<P> properties)` Get a builder to create a `PropertyViewForm` using given property set.
    `static <C extends com.vaadin.flow.component.Component> PropertyViewFormBuilder<C>` | `form(C content, com.holonplatform.core.property.Property<?>... properties)` Get a builder to create a `PropertyViewForm` using given property set.
    `static <P extends com.holonplatform.core.property.Property> PropertyViewFormBuilder<com.vaadin.flow.component.formlayout.FormLayout>` | `form(Iterable<P> properties)` Get a builder to create a `PropertyViewForm` using given property set and a `FormLayout` as content layout.
    `static PropertyViewFormBuilder<com.vaadin.flow.component.formlayout.FormLayout>` | `form(com.holonplatform.core.property.Property<?>... properties)` Get a builder to create a `PropertyViewForm` using given property set and a `FormLayout` as content layout.
    `static <P extends com.holonplatform.core.property.Property> PropertyViewFormBuilder<com.vaadin.flow.component.orderedlayout.HorizontalLayout>` | `formHorizontal(Iterable<P> properties)` Get a builder to create a `PropertyViewForm` using given property set and a `HorizontalLayout` as content layout.
    `static PropertyViewFormBuilder<com.vaadin.flow.component.orderedlayout.HorizontalLayout>` | `formHorizontal(com.holonplatform.core.property.Property<?>... properties)` Get a builder to create a `PropertyViewForm` using given property set and a `HorizontalLayout` as content layout.
    `static <P extends com.holonplatform.core.property.Property> PropertyViewFormBuilder<com.vaadin.flow.component.orderedlayout.VerticalLayout>` | `formVertical(Iterable<P> properties)` Get a builder to create a `PropertyViewForm` using given property set and a `VerticalLayout` as content layout.
    `static PropertyViewFormBuilder<com.vaadin.flow.component.orderedlayout.VerticalLayout>` | `formVertical(com.holonplatform.core.property.Property<?>... properties)` Get a builder to create a `PropertyViewForm` using given property set and a `VerticalLayout` as content layout.
    `static <T> ViewComponent<T>` | `property(com.holonplatform.core.property.Property<T> property)` Create a `ViewComponent` using given `Property` for label and value presentation through the `Property.present(Object)` method.
    `static <P extends com.holonplatform.core.property.Property> PropertyViewGroupBuilder` | `propertyGroup(Iterable<P> properties)` Get a `PropertyViewGroupBuilder` to create and setup a `PropertyViewGroup`.
    `static PropertyViewGroupBuilder` | `propertyGroup(com.holonplatform.core.property.Property<?>... properties)` Get a `PropertyViewGroupBuilder` to create and setup a `PropertyViewGroup`.
    `static <T> ViewComponent<T>` | `type(Class<T> valueType)` Create a `ViewComponent` using given value type.

- - ### Method Detail

    - #### component

          static <T> ViewComponentBuilder<T> component(Class<? extends T> valueType)

      Get a `ViewComponentBuilder` to create a `ViewComponent` using given value type.
      Type Parameters:
        `T` - Value type
      Parameters:
        `valueType` - Value type (not null)
      Returns:
        A `ViewComponentBuilder`

    - #### component

          static <T> ViewComponentBuilder<T> component(com.holonplatform.core.property.Property<T> property)

      Get a `ViewComponentBuilder` to create a `ViewComponent` using given `Property` for label and value presentation through the `Property.present(Object)` method.
      Type Parameters:
        `T` - Value type
      Parameters:
        `property` - The property to use (not null)
      Returns:
        A `ViewComponentBuilder`

    - #### component

          static <T> ViewComponentBuilder<T> component(Function<T,String> stringValueConverter)

      Get a `ViewComponentBuilder` to create a `ViewComponent` using given function to convert the value to a `String` type representation.
      Type Parameters:
        `T` - Value type
      Parameters:
        `stringValueConverter` - Value converter function (not null)
      Returns:
        A `ViewComponentBuilder`

    - #### type

          static <T> ViewComponent<T> type(Class<T> valueType)

      Create a `ViewComponent` using given value type.
      Type Parameters:
        `T` - Value type
      Parameters:
        `valueType` - Value type (not null)
      Returns:
        A `ViewComponent` instance

    - #### property

          static <T> ViewComponent<T> property(com.holonplatform.core.property.Property<T> property)

      Create a `ViewComponent` using given `Property` for label and value presentation through the `Property.present(Object)` method.
      Type Parameters:
        `T` - Value type
      Parameters:
        `property` - The property to use (not null)
      Returns:
        A `ViewComponent` instance

    - #### propertyGroup

          static <P extends com.holonplatform.core.property.Property> PropertyViewGroupBuilder propertyGroup(Iterable<P> properties)

      Get a `PropertyViewGroupBuilder` to create and setup a `PropertyViewGroup`.
      Type Parameters:
        `P` - Property type
      Parameters:
        `properties` - The property set (not null)
      Returns:
        A new `PropertyViewGroupBuilder`

    - #### propertyGroup

          static PropertyViewGroupBuilder propertyGroup(com.holonplatform.core.property.Property<?>... properties)

      Get a `PropertyViewGroupBuilder` to create and setup a `PropertyViewGroup`.
      Parameters:
        `properties` - The property set (not null)
      Returns:
        A new `PropertyViewGroupBuilder`

    - #### form

          static <C extends com.vaadin.flow.component.Component,P extends com.holonplatform.core.property.Property> PropertyViewFormBuilder<C> form(C content,
                                                                                                                                                    Iterable<P> properties)

      Get a builder to create a `PropertyViewForm` using given property set.
      Type Parameters:
        `C` - Form content element type
        `P` - Property type
      Parameters:
        `content` - The form content, where the `ViewComponent`s will be composed using the configured `Composable.Composer` (not null)
        `properties` - The property set (not null)
      Returns:
        A new `PropertyViewFormBuilder`

    - #### form

          static <C extends com.vaadin.flow.component.Component> PropertyViewFormBuilder<C> form(C content,
                                                                                                 com.holonplatform.core.property.Property<?>... properties)

      Get a builder to create a `PropertyViewForm` using given property set.
      Type Parameters:
        `C` - Form content element type
      Parameters:
        `content` - The form content, where the `ViewComponent`s will be composed using the configured `Composable.Composer` (not null)
        `properties` - The property set (not null)
      Returns:
        A new `PropertyViewFormBuilder`

    - #### form

          static <P extends com.holonplatform.core.property.Property> PropertyViewFormBuilder<com.vaadin.flow.component.formlayout.FormLayout> form(Iterable<P> properties)

      Get a builder to create a `PropertyViewForm` using given property set and a `FormLayout` as content layout.

      A default composer is configured using `Composable.componentContainerComposer()`. Use `ComposableConfigurator.composer(com.holonplatform.vaadin.flow.components.Composable.Composer)` to provide a custom components composer.

      Type Parameters:
        `P` - Property type
      Parameters:
        `properties` - The property set (not null)
      Returns:
        A `PropertyViewForm` builder

    - #### form

          static PropertyViewFormBuilder<com.vaadin.flow.component.formlayout.FormLayout> form(com.holonplatform.core.property.Property<?>... properties)

      Get a builder to create a `PropertyViewForm` using given property set and a `FormLayout` as content layout.

      A default composer is configured using `Composable.componentContainerComposer()`. Use `ComposableConfigurator.composer(com.holonplatform.vaadin.flow.components.Composable.Composer)` to provide a custom components composer.

      Parameters:
        `properties` - The property set (not null)
      Returns:
        A `PropertyViewForm` builder

    - #### formVertical

          static <P extends com.holonplatform.core.property.Property> PropertyViewFormBuilder<com.vaadin.flow.component.orderedlayout.VerticalLayout> formVertical(Iterable<P> properties)

      Get a builder to create a `PropertyViewForm` using given property set and a `VerticalLayout` as content layout.

      A default composer is configured using `Composable.componentContainerComposer()`. Use `ComposableConfigurator.composer(com.holonplatform.vaadin.flow.components.Composable.Composer)` to provide a custom components composer.

      Type Parameters:
        `P` - Property type
      Parameters:
        `properties` - The property set (not null)
      Returns:
        A `PropertyViewForm` builder

    - #### formVertical

          static PropertyViewFormBuilder<com.vaadin.flow.component.orderedlayout.VerticalLayout> formVertical(com.holonplatform.core.property.Property<?>... properties)

      Get a builder to create a `PropertyViewForm` using given property set and a `VerticalLayout` as content layout.

      A default composer is configured using `Composable.componentContainerComposer()`. Use `ComposableConfigurator.composer(com.holonplatform.vaadin.flow.components.Composable.Composer)` to provide a custom components composer.

      Parameters:
        `properties` - The property set (not null)
      Returns:
        A `PropertyViewForm` builder

    - #### formHorizontal

          static <P extends com.holonplatform.core.property.Property> PropertyViewFormBuilder<com.vaadin.flow.component.orderedlayout.HorizontalLayout> formHorizontal(Iterable<P> properties)

      Get a builder to create a `PropertyViewForm` using given property set and a `HorizontalLayout` as content layout.

      A default composer is configured using `Composable.componentContainerComposer()`. Use `ComposableConfigurator.composer(com.holonplatform.vaadin.flow.components.Composable.Composer)` to provide a custom components composer.

      Type Parameters:
        `P` - Property type
      Parameters:
        `properties` - The property set (not null)
      Returns:
        A `PropertyViewForm` builder

    - #### formHorizontal

          static PropertyViewFormBuilder<com.vaadin.flow.component.orderedlayout.HorizontalLayout> formHorizontal(com.holonplatform.core.property.Property<?>... properties)

      Get a builder to create a `PropertyViewForm` using given property set and a `HorizontalLayout` as content layout.

      A default composer is configured using `Composable.componentContainerComposer()`. Use `ComposableConfigurator.composer(com.holonplatform.vaadin.flow.components.Composable.Composer)` to provide a custom components composer.

      Parameters:
        `properties` - The property set (not null)
      Returns:
        A `PropertyViewForm` builder

Copyright © 2019 The Holon Platform. All rights reserved.